%define name cups-drivers
%define version 0.3.6
%define release 30mdk

Summary: Common Unix Printing System - Drivers (all)
Name: %{name}
Version: %{version}
Release: %{release}
Copyright: GPL
Group: System/Servers
# Old CUPS-Drivers package from Sourceforge, will be removed when Grant Taylors
# CUPS-O-MATIC-database is complete
Source: ftp://cups.sourceforge.net/pub/cups/cups-drivers/%{version}/%{name}-all-%{version}.tar.bz2
Url: http://www.linuxprinting.org
# Perl script for the Sourceforge CUPS-Drivers package
Source1: pstogstoraster.bz2
# Snapshot of Grant Taylors CUPS-O-MATIC PPD files
Source2: http://www.linuxprinting.org/all-com-ppds.tar.bz2
# Perl script to clean up Manufacturer entries in the PPD files, so that
# drivers are sorted by the printer Manufacturer in the graphical frontends
Source4: cleanppd.pl.bz2
# GIMP-Print CUPS drivers
Source5: http://gimp-print.sourceforge.net/print-4.0.0rc1.tar.bz2
# Icon for the Mandrake menu
Source6: calibrate.png.bz2
# Printing HOWTO
Source7: http://www.linuxprinting.org/Printing-HOWTO.tar.bz2
# Patch to make Sourceforge drivers using the pstogstoraster perl script
Patch: cups-drivers-pstogstoraster.patch.bz2
# Fix buggy PPD file
Patch1: cups-drivers-hplj5m_4.ppd.patch.bz2
# Patch to make the calibration program for the GIMP-Print CUPS drivers more
# userfriendly
#Patch2: print-4.0-calibrate.patch.bz2
# Patch the cupsomatic filter to allow PJL options
Patch3: cupsomatic-pjl.patch.bz2
# CRET support for the HP DeskJet 840C in the GIMP-Print CUPS driver
Patch4: print-4.0-cret-HP840C.patch.bz2
# CRET support for the HP DeskJet 840C in the PPD files for the GIMP-Print
# GhostScript driver, fixes for HP LaserJet 1100/4050 stp PPDs.
Patch5: all-com-ppds-cret-HP840C.patch.bz2
# Bugfix in Epson printer maintenance utility
Patch6: print-4.0-escputil.patch.bz2
# Bugfix to allow 600 dpi on the LaserJet 4V and 4Si
Patch7: print-4.0-LJ4VSi-600dpi.patch.bz2
Patch8: all-com-ppds-LJ4VSi-600dpi.patch.bz2
BuildRoot: %{_tmppath}/%{name}-buildroot
Requires: cups >= 1.1, /usr/bin/perl, ghostscript >= 5.50-33mdk
Prefix: /usr

%description
The Common Unix Printing System provides a portable printing layer for
UNIX(TM) operating systems.

This package contains free printer driver descriptions to be used with
CUPS. Especially it contains a recent snapshot of the printer database
on www.linuxprinting.org. and the CUPS drivers of GIMP-Print which
allow photo-quality printing on ink jets. Not that the calibration
program "calibrate" is renamed to "calibrate-gimpprint" here.

%prep
# Uncompress Sourceforge drivers
%setup
# Apply patch to get Perl script used
%patch -p1
# Apply patch for buggy ppd file
%patch1 -p1
# Remove CUPS-O-MATIC PPDs to do not have these PPDs twice
rm -rf usr/share/cups/model/cups-o-matic
# Load Printing HOWTO
%setup -T -D -a 7 -c -n %{name}-%{version}/pht
# Uncompress Grants recent CUPS-O-MATIC PPDs
%setup -T -D -a 2 -n %{name}-%{version}
# Patch the cupsomatic script to allow PJL options
%patch3
# CRET support for the HP DeskJet 840C in the PPD files for the GIMP-Print
# GhostScript driver, fixes for HP LaserJet 1100/4050 stp PPDs.
%patch5
# 600 dpi for the HP LaserJet 4V and 4Si printers
%patch8
# Change odd PPD file names
mv 'cupsomatic-ppd/ppd/Kyocera/FS-600_(KPDL-2)-Postscript.ppd' cupsomatic-ppd/ppd/Kyocera/FS-600_KPDL-2-Postscript.ppd
mv 'cupsomatic-ppd/ppd/Hitachi/DDP_70_(with_MicroPress)-Postscript.ppd' cupsomatic-ppd/ppd/Hitachi/DDP_70_with_MicroPress-Postscript.ppd
# Load GIMP-Print package
%setup -T -D -a 5 -n %{name}-%{version}
cd print-4.0.0rc1
# Patch calibration program for native CUPS drivers of GIMP-Print
#patch2
# Patch GIMP-Print CUPS driver for PCL to support CRET on the DeskJet 840C
# The previous commands regenerate the file treated by this patch. so the
# they are here and not in the build section.
%patch4
# Bugfix for Epson printer maintenance utility
%patch6
# Bugfix to allow 600 dpi on the LaserJet 4V and 4Si
%patch7
cd ..
# Load menu icon
bzcat %{SOURCE6} > $RPM_BUILD_DIR/%{name}-%{version}/calibrate.png
# Generate README file
cat <<EOF >README

CUPS-Drivers package
--------------------

This package does not actually contain the drivers for the printers,
they are in the GhostScript package, but it contains the descriptions
of the printer drivers and how the printing system CUPS has to use
them. For every printer this description is stored in a *.ppd file
which is located in /usr/share/cups/model or in one of its
subdirectories. These files form also the lists of supported printer
models in the printer administration programs "printerdrake", "kups",
and the WWW interface of CUPS (http://localhost:631/). If your printer
is not listed by these programs, go to

   http://www.linuxprinting.org/

and download the CUPS PPD file for your printer there. Copy it into a
subdirectory of /usr/share/cups/model and restart the CUPS daemon
entering

   /etc/rc.d/init.d/cups restart

(Otherwise the WWW interface and "printerdrake" will not find the new
PPD file and so they will not list your printer.)

If you have an HP DeskJet PPA printer (very cheap models: 710C, 712C,
720C, 722C, 820C, 1000C, or a newer printer which works with one of
these model entries) you can optionally do a colour correction. Do the
following:

Some of the printing modes offer optional colour correction. See the
option "Printing Mode" which is offered to you in "qtcups"
("Properties" button, "Advanced" tab), "xpp" ("Options" button,
"Extra" tab), "kups" (right click on printer, "Configure printer" in
menu), or the WWW interface ("Configure printer" button). Choose a
setting with "optional colour correction" and save your settings. Read
the file

   /usr/share/doc/ghostscript-5.50/HPDeskJetPPA/pnm2ppa/COLOR.txt

and follow the instructions there, but use the name

   /etc/pnm2ppa.gamma_normal

for the colour correction file for the "normal quality" modes and

   /etc/pnm2ppa.gamma_best

for the colour correction file for the "best quality" modes. So you
can do the colour correction independently in both normal and best
quality modes. The files are automatically taken into account by the
appropriate modes as soon as they are created.



EOF

%build

cd print-4.0.0rc1
# If stp driver is a CVS version, so some preparation is needed (see its 
# README)
aclocal
autoconf
automake
# both configure and make with percent
%configure --disable-gimptest
%make cups
# Compile the filters and utilities
%make escputil
cd cups
# configure with percent, make without
%configure
make
cd ../..

%install
rm -rf $RPM_BUILD_ROOT
# Put Sourceforge PPDs into CUPS driver directory
mkdir -p $RPM_BUILD_ROOT%{prefix}/share/cups
cp -a usr/share/cups/model $RPM_BUILD_ROOT%{prefix}/share/cups
# Place Perl script in CUPS filter directory
mkdir -p $RPM_BUILD_ROOT%{prefix}/lib/cups/filter
bzcat %{SOURCE1} >$RPM_BUILD_ROOT%{prefix}/lib/cups/filter/pstogstoraster
# Put Grants PPDs into CUPS driver directory
cp -a cupsomatic-ppd/ppd/* $RPM_BUILD_ROOT%{prefix}/share/cups/model
# Place CUPS-O-MATIC script in CUPS filter directory
cp cupsomatic-ppd/cupsomatic $RPM_BUILD_ROOT%{prefix}/lib/cups/filter
# Install CUPS drivers of GIMP-Print
cd print-4.0.0rc1/cups
# Create necessary directory
mkdir -p $RPM_BUILD_ROOT/etc/cups
# Remove hardcoded directory entries in Makefile
sed "s:/usr:$RPM_BUILD_ROOT/usr:" Makefile > Makefile.new
mv -f Makefile.new Makefile
sed "s:\$(PREFIX)/etc/cups:$RPM_BUILD_ROOT/etc/cups:" Makefile > Makefile.new
mv -f Makefile.new Makefile
# make install with percent
%makeinstall
cd ..
# install Epson printer maintenance utility
mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -m 755 escputil $RPM_BUILD_ROOT%{_bindir}
cd ..
# Rename "calibrate" because pnm2ppa has a "calibrate" program, too.
( cd $RPM_BUILD_ROOT%{_bindir}
  mv calibrate calibrate-gimpprint
)
# Do not leave the PPD directory SO chaotic
( cd $RPM_BUILD_ROOT%{prefix}/share/cups/model
  mkdir gimp-print
  mv *.gz gimp-print
  gunzip gimp-print/*
)
# Remove pstogstoraster-based PPD files, they do not work 
# when printing via Samba. There are other, better PPDs for 
# these printers.
rm -f $RPM_BUILD_ROOT/usr/share/cups/model/canon/bj10.ppd
rm -f $RPM_BUILD_ROOT/usr/share/cups/model/hp/djet_890c.ppd
rm -f $RPM_BUILD_ROOT/usr/share/cups/model/hp/laserjet_gs.ppd
# Correct permissions of driver directory
chmod -R u+w,a+rX $RPM_BUILD_ROOT%{prefix}/share/cups/model
# Uncompress Perl script for cleaning up manufacturer entries in PPD files
bzcat %{SOURCE4} > ./cleanppd.pl
chmod a+rx ./cleanppd.pl
# Do the clean-up 
find $RPM_BUILD_ROOT%{prefix}/share/cups/model -name "*.ppd" -print -exec ./cleanppd.pl '{}' \;

# Install a script to display the test page on the screen for colour
# adjustment
cat <<EOF > $RPM_BUILD_ROOT%{_bindir}/cupsDisplayTestpage
#!/bin/sh
ps2img="gs -dQUIET -dNOPAUSE -dBATCH -sDEVICE=pnm -r75x75 -sOUTPUTFILE=- -"
testpage=/usr/share/cups/data/testprint.ps

TMPFILE=~/.cupsDisplayTestpage.pnm
if [ -x /usr/bin/kview ]; then
  cat \$testpage | \$ps2img > \$TMPFILE 
  /usr/bin/kview \$TMPFILE
elif [ -x /usr/bin/ee ]; then
  cat \$testpage | \$ps2img > \$TMPFILE 
  /usr/bin/ee \$TMPFILE
elif [ -x /usr/bin/gqview ]; then
  cat \$testpage | \$ps2img > \$TMPFILE 
  /usr/bin/gqview \$TMPFILE
elif [ -x /usr/bin/xv ]; then
  cat \$testpage | \$ps2img | /usr/bin/xv -
elif [ -x /usr/bin/kghostview ]; then
  /usr/bin/kghostview \$testpage
elif [ -x /usr/X11R6/bin/gv ]; then
  /usr/X11R6/bin/gv \$testpage
elif [ -x /usr/X11R6/bin/ghostview ]; then
  /usr/X11R6/bin/ghostview \$testpage
else
  xmessage "No suitable program for viewing PostScript found, install GhostView, gv, or similar."
  exit 1
fi
rm \$TMPFILE
EOF
chmod a+rx $RPM_BUILD_ROOT/usr/bin/cupsDisplayTestpage

# Install documentation (Printing HOWTO, README)
mkdir -p $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}-%{version}
cp -ax pht/* $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}-%{version}
cp README $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}-%{version}
cp print-4.0.0rc1/cups/README.txt $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}-%{version}/README.gimp-print-cups

# Install menu icon

mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/locolor/16x16/apps/
install -m 644 calibrate.png $RPM_BUILD_ROOT%{_datadir}/icons/locolor/16x16/apps/

# install menu entry
mkdir -p $RPM_BUILD_ROOT/usr/lib/menu

cat <<EOF > $RPM_BUILD_ROOT/usr/lib/menu/cups-drivers
?package(cups-drivers): needs=X11 \
section=Configuration/Printing \
title="Display printer test page (for colour adjustment)" \
command="/usr/bin/cupsDisplayTestpage" \
icon="/usr/share/icons/locolor/16x16/apps/calibrate.png"
?package(cups-drivers): needs=text \
section=Configuration/Printing \
title="Calibrate colour printer (GIMP-Print CUPS drivers)" \
command="/usr/bin/calibrate-gimpprint; echo 'Press ENTER to close this window!'; read" \
icon="/usr/share/icons/locolor/16x16/apps/calibrate.png"
?package(cups-drivers): needs=text \
section=Configuration/Printing \
title="Epson inkjet printer maintenance" \
command="/usr/bin/escputil --help -q | less" \
icon="/usr/share/icons/locolor/16x16/apps/calibrate.png"
EOF

%post

# Restart the CUPS daemon to refresh the database
! ( lpstat -r 1> /dev/null 2>&1 ) || (
  %{_initrddir}/cups stop 1> /dev/null 2>&1
  rm -f /etc/cups/ppds.dat
  rm -f /var/spool/cups/[cd]*
  rm -f /var/spool/cups/tmp/*
  %{_initrddir}/cups start 1> /dev/null 2>&1
)

##menu
if [ -x /usr/bin/update-menus ]; then
        /usr/bin/update-menus
fi

%postun

if [ "$1" = 0 ]; then

	# Restart the CUPS daemon to refresh the database
	! ( lpstat -r 1> /dev/null 2>&1 ) || (
	    %{_initrddir}/cups stop 1> /dev/null 2>&1
	    rm -f /etc/cups/ppds.dat
	    rm -f /var/spool/cups/[cd]*
	    rm -f /var/spool/cups/tmp/*
	    %{_initrddir}/cups start 1> /dev/null 2>&1
	)
 
	## menu
	if [ -x /usr/bin/update-menus ]; then
                /usr/bin/update-menus
        fi
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{_datadir}/cups/model
%attr(0755,root,root) %{_libdir}/cups/filter/*
%attr(0755,root,root) %{_libdir}/cups/backend/*
%attr(0755,root,root) %{_bindir}/*
%config(noreplace) %{_sysconfdir}/cups/*
# menu entry
%{_datadir}/icons/locolor/16x16/apps
%{_libdir}/menu
# documentation
%doc %{_defaultdocdir}/%{name}-%{version}

%changelog

* Tue Oct 24 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-30mdk
- Bugfixes on the CRET support for the HP DeskJet 840C

* Mon Oct 23 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-29mdk
- Fixed bug which prevented GIMP-Print from doing 600 dpi on the
  LaserJet 4V and 4Si

* Sun Oct 22 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-28mdk
- Included Epson printer maintenance tool of GIMP-Print
- Applied escputil bug fix patch on GIMP-Print

* Fri Oct 20 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-27mdk
- Updated GIMP-Print code to 4.0.0rc1
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database
- CRET support for the HP DeskJet 840C in the GIMP-Print CUPS driver
- Updated Printing-HOWTO

* Mon Oct 16 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-26mdk
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database
- Reactivated the building of the native CUPS drivers of GIMP-Print
- Made the calibration program for the GIMP-Print CUPS drivers more
  userfriendly

* Tue Oct  3 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-25mdk
- pstogstoraster-based drivers removed (problems with Samba)

* Mon Oct  2 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-24mdk
- Fixed bug in Grant Taylors PPDs for the pnm2ppa driver
- Added README file

* Sat Sep 30 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-23mdk
- Better correction of the manufacturer names

* Fri Sep 29 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-22mdk
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database

* Thu Sep 28 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-21mdk
- Added a menu entry for displaying the printer test page on the screen
  (for colour adjustment).

* Thu Sep 28 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-20mdk
- Added Grant Taylor's printing HOWTO as documentation
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database
  (now there are PPD files for all printers which were 
   supported by Mandrake in the LPD era)

* Tue Sep 26 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-19mdk
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database
  (the database is fixed again)

* Tue Sep 26 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-18mdk
- Downdated the CUPS-O-MATIC-PPDs from Grant Taylors database because the
  whole database was broken

* Tue Sep 26 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-17mdk
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database
- Updated cupsomatic backend filter because of bugs

* Mon Sep 25 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-16mdk
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database
- Updated cupsomatic backend filter to support numerical options

* Fri Sep 22 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-15mdk
- GIMP-Print CUPS drivers taken out, they are completely broken, and
  for each of these printers there is also a PPD file for the 
GhostScript "stp" driver.
- Last steps completely messed up, and uploaded accidentally
  (instead of cups-devel), tried again ...

* Fri Sep 22 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-14mdk
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database
- Updated GIMP-Print code to 4.0b1
- Edited cleanppd.pl to comment also the lex5700/7000 drivers.

* Sun Sep 17 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-13mdk
- Corrected the information to distuinguish the PPD files.
  The PPD files of the GIMP-Print CUPS drivers (not of the
  GIMP-Print GhostScript ("stp") driver) do not like to be
  modified.

* Sat Sep 16 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-12mdk
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database
- Added informtion in the PPD files so that one can distinguish them 
  when there are several drivers for one printer.

* Wed Sep 13 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-11mdk
- Removed "Buildarchitecture: i586" line from specfile so that
  package works on all architectures.

* Mon Sep 11 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-10mdk
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database
- Added GIMP-Print CUPS drivers

* Fri Sep  7 2000 Till Kamppeter <till@mandrakesoft.com> 0.3.6-9mdk
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database

* Wed Sep  6 2000 Till Kamppeter <tkamppeter@mandrakesoft.com> 0.3.6-8mdk
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database

* Sun Sep  2 2000 Till Kamppeter <tkamppeter@mandrakesoft.com> 0.3.6-7mdk
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database

* Tue Aug 31 2000 Till Kamppeter <tkamppeter@mandrakesoft.com> 0.3.6-6mdk
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database
- Added script to restart the CUPS daemon for refreshing the driver data
  base to post-inatall

* Tue Aug 29 2000 Till Kamppeter <tkamppeter@mandrakesoft.com> 0.3.6-5mdk
- Updated the CUPS-O-MATIC-PPDs from Grant Taylors database

* Wed Aug 11 2000 Till Kamppeter <tkamppeter@mandrakesoft.com> 0.3.6-4mdk
- Cleaned up Manufacturer entries in the PPD files, now the printer drivers
  appear sorted by the printer manufacturer in graphical administration
  frontends (as KUPS or the web interface of CUPS)
- Added PPD file for the GIMP-Print stp Epson Stylus driver in GhostScript
  (modified because of some bugs)

* Wed Aug  9 2000 Till Kamppeter <tkamppeter@mandrakesoft.com> 0.3.6-3mdk
- added "ghostscript" to "Requires:" line

* Tue Aug  8 2000 Till Kamppeter <tkamppeter@mandrakesoft.com> 0.3.6-2mdk
- added Grant Taylors CUPS-O-MATIC driver package

* Tue Jul  4 2000 Franois Pons <fpons@mandrakesoft.com> 0.3.6-1mdk
- replaced ps2gs2raw.* by pstogstoraster (perl script only).
- initial release.

